//////////////////////////////////////////////////////////////////////////////
//
// AutoPitLot v2.0
// Modu odczytu stanu odbiornika RC
//
// (c) Pit Lab
// http://www.pitlab.pl
//////////////////////////////////////////////////////////////////////////////
#include "LPC1768.h"
#include "sys_def.h"
#include "errors.h"
#include "OSD_Zbig.h"
#include <stdio.h>
#include <string.h>
#include <math.h>

////////////////////////////////////////////////////////////////////////////////
// Zarzdza wywietlaniem danych na ekranie OSD
// Parametry: 
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OSD_Zbig(void)
{
    unsigned char x, chErr = ERR_OK;
    extern float fVectAngle[];
    extern float fVectAccANorm[];     //wektor znormalizowanych przyspiesze w 3 osiach na podstaiwe danych akcelerometru
    extern float fUserSensCurr[];    //prd z czujnika prdu i napiecia
    extern float fUserSensVolt[];    //napicie z czujnika prdu i napiecia
    extern float fEnergy[];          //energia pobrana z  pakietw
    extern float fVario;	//prdko pionowa z wariometru
    extern float fIAS;	//prdkoc powietrza przyrzdowa, zmierzona rnicowym czujnikiem cinienia
    extern float fAlti;	//wysoko mierzona czujnikiem cinienia
    extern float fMagnCourseMMC0, fMagnCourseMMC1, fMagnCourseMMC2;     //wyliczony kurs magnetyczny

    float fTest[3];
    signed char chTest[3];

    switch (chFrameDivider++)
    {
      /*case 0:   OZ_SetLayout(OZ_BLANK);         break;
      case 2:   OZ_ClearScreen();               break;
      case 4:   OZ_PrintText("Test", 4);        break;
      case 6:   OZ_SetTextPosition(5, 16);      break;
      case 8:   OZ_PrintText("Example", 7);     break;
      case 12:  OZ_SetTextPosition(0, 32);      break;
      case 14:  OZ_PrintText("AutoPitLot", 10); break;
          
      case 120: OZ_SetLayout(OZ_F16);           break;*/
      case 2:   OZ_SetHorizon(fVectAngle[1], fVectAngle[0]);    break;
                //OZ_SetHorizon((signed char)(fVectAngle[0]*RAD2DEG), (signed char)(fVectAngle[1]*RAD2DEG), (signed char)(fVectAngle[2]*RAD2DEG));    break;
                //OZ_SetHorizon((signed char)(fVectAngle[0]*RAD2DEG), (signed char)(fVectAngle[1]*RAD2DEG), (signed char)(90));    break;
                /*for (x=0; x<3; x++)
                    chTest[x] = (signed char)(asinf(fVectAccANorm[x])*RAD2DEG);
                OZ_SetHorizon(chTest[1], -chTest[0], chTest[2]);    break;*/
           
                //odtwarzam wartoci akcelerometru na podstawie  katw
                /*fTest[0] = sinf(fVectAngle[1]);
                fTest[1] = sinf(fVectAngle[0]);
                fTest[2] = cosf(fVectAngle[0]) * cosf(fVectAngle[1]);
                for (x=0; x<3; x++)
                    chTest[x] = (signed char)(asinf(fTest[x])*RAD2DEG);
                OZ_SetHorizon(chTest[1], chTest[0], chTest[2]);    break;*/
      case 3:   OZ_SetCurrEnergy(fUserSensCurr[0], fEnergy[0]); break;
      case 4:   OZ_SetAltitude(fAlti);  break;
      case 5:   OZ_SetVariometer(fVario);  break;
      case 6:   OZ_SetSpeed(fIAS);  break;
      case 7:   OZ_SetCourse(fMagnCourseMMC2);     break;
      case 8:   OZ_SetVoltage(fUserSensVolt[0]);    break;
      
      
      case 10:  chFrameDivider = 0; break;  //160/25Hz = 6,5
    }
    return chErr;
}


////////////////////////////////////////////////////////////////////////////////
// Zarzdza wywietlaniem danych na ekranie OSD
// Parametry: 
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char InitOSD_Zbig(void)
{
    SetUartSpeed(3, 19200); //ustaw prdko portu UART
    OZ_SetLayout(OZ_F16);
}


////////////////////////////////////////////////////////////////////////////////
// koduje liczby 8-bitowe w format zrozumiay dla OSD
// Parametry: 
// [i] chDig - liczba do konwersji
// [o] *chBuf -wskanik na bufor do umieszczenia znakw
// Zwraca: nic
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
void OZ_Byte2Char(unsigned char chDig, unsigned char *chBuf)
{
    *chBuf++ = ((chDig >> 4) & 0x0F) + 'A';
    *chBuf   = ((chDig) & 0x0F) + 'A';
}


////////////////////////////////////////////////////////////////////////////////
// koduje liczby 16-bitowe w format zrozumiay dla OSD
// Parametry: 
// [i] chDig - liczba do konwersji
// [o] *chBuf -wskanik na bufor do umieszczenia znakw
// Zwraca: nic
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
void OZ_Short2Char(unsigned short sDig, unsigned char *chBuf)
{
    *chBuf++ = (unsigned char)((sDig >> 12) & 0x000F) + 'A';
    *chBuf++ = (unsigned char)((sDig >>  8) & 0x000F) + 'A';
    *chBuf++ = (unsigned char)((sDig >>  4) & 0x000F) + 'A';
    *chBuf   = (unsigned char)(sDig & 0x000F) + 'A';
}


////////////////////////////////////////////////////////////////////////////////
// Wywietla napis na OSD w tryboe ekranu = (-1)
// Parametry: 
// [i] *chText - wskanik na ciag z napisem
// [i] chTextLen - ilo znakw napisu
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
//unsigned char OZ_PrintText(unsigned char chPosX, unsigned char chPosY, unsigned char *chText, unsigned char chTextLen)
unsigned char OZ_PrintText(unsigned char *chText, unsigned char chTextLen)
{
    unsigned char chLen, chBuf[43];
    if (chTextLen > 40)
        return ERR_TOO_LONG_STR;

    chLen = sprintf(chBuf, "P%c%s\n", (chTextLen & 0x0F) + '0', chText);  
    PutData3(chBuf, chLen);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia jeden z predefiniowanych ukadw ekranu
// Parametry: 
// [i] chLayout - tryb pracy
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetLayout(unsigned char chLayout)
{
    unsigned char chBuf[5] = "L2cc\n";

    OZ_Byte2Char(chLayout, &chBuf[2]);
    PutData3(chBuf, 5);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// czyci ekran w trybie OZ_BLANK
// Parametry: brak
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_ClearScreen(void)
{
    unsigned char chBuf[3] = "C0\n";
    PutData3(chBuf, 3);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// ustawia pozycj dla tekstu w trybie OZ_BLANK
// Parametry: 
// sPosX - wsprzedne X w zakresie 0..288
// sPosY - wsprzedne Y w zakresie 0..280
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetTextPosition(unsigned short sPosX, unsigned short sPosY)
{
    unsigned char chBuf[11] = "X8xxxxyyyy\n";
    OZ_Short2Char(sPosX, &chBuf[2]);
    OZ_Short2Char(sPosY, &chBuf[6]);
    PutData3(chBuf, 11);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia pooenie sztucznego horyzontu
// Parametry: 
// fPith - kt pochylenia +-90
// fRoll - kt przechylenia +-180
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetHorizon(float fPith, float fRoll)
{
    unsigned char chBuf[11] = "H8pppprrrr\n";

    //kty wchodz jako dziesiete czci stopnia
    OZ_Short2Char((signed short)(10 * fPith * RAD2DEG), &chBuf[2]);
    OZ_Short2Char((signed short)(10 * fRoll * RAD2DEG), &chBuf[6]);
    PutData3(chBuf, 11);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia dane napicia baterii
// Parametry: 
// fVolt - pnapicie 0,1 [V]
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetVoltage(float fVolt)
{
    unsigned char chBuf[7] = "U4vvvv\n";

    OZ_Short2Char((signed short)(10 * fVolt), &chBuf[2]);
    PutData3(chBuf, 7);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia dane wartoci prdi i rozadowania baterii
// Parametry: 
// fCurr - pobierany prd [0,1 A]
// fEnergy - energia pobrana z pakietu w [mAh]
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetCurrEnergy(float fCurr, float fEnergy)
{
    unsigned char chBuf[11] = "I8iiiieeee\n";

    OZ_Short2Char((signed short)(10 * fCurr), &chBuf[2]);
    OZ_Short2Char((signed short)(fEnergy), &chBuf[6]);
    PutData3(chBuf, 11);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia dane wysokoci
// Parametry: 
// fAlti - wysoko w metrach [m]
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetAltitude(float fAlti)
{
    unsigned char chBuf[7] = "A4aaaa\n";

    OZ_Short2Char((signed short)(fAlti), &chBuf[2]);
    PutData3(chBuf, 7);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia dane wariometru
// Parametry: 
// fVario - prdko pionowa [m/s]
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetVariometer(float fVario)
{
    unsigned char chBuf[7] = "V4vvvv\n";

    OZ_Short2Char((signed short)(fVario), &chBuf[2]);
    PutData3(chBuf, 7);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia dane prdkoci
// Parametry: 
// fVario - prdko wzgledem powietrza [km/h]
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetSpeed(float fSpeed)
{
    unsigned char chBuf[5] = "S2ss\n";

    //trzeba przeliczy m/s na km/h
    OZ_Byte2Char((signed char)(fSpeed/3.6), &chBuf[2]);
    PutData3(chBuf, 5);  
    return ERR_OK;
}


////////////////////////////////////////////////////////////////////////////////
// Ustawia kurs magnetyczny
// Parametry: 
// fCourse - kurs 0-359 []
// Zwraca: kod bdu
// Czas wykonania 
////////////////////////////////////////////////////////////////////////////////
unsigned char OZ_SetCourse(float fCourse)
{
    unsigned char chBuf[7] = "O4cccc\n";

    OZ_Short2Char((signed short)(fCourse), &chBuf[2]);
    PutData3(chBuf, 7);  
    return ERR_OK;
}